// Import necessary modules and plugins
const path = require('path'); // Provides utilities for working with file paths
const webpack = require('webpack'); // Webpack for bundle management
const { CleanWebpackPlugin } = require('clean-webpack-plugin'); // Plugin to clean the "dist" folder
const MiniCssExtractPlugin = require('mini-css-extract-plugin'); // Extracts CSS into separate files
const TerserPlugin = require('terser-webpack-plugin'); // Plugin to minimize JS files
const autoprefixer = require('autoprefixer'); // Automatically adds CSS prefixes for browser compatibility
const RemoveEmptyScriptsPlugin = require('webpack-remove-empty-scripts'); // Removes empty JS files generated by the compiler
const glob = require('glob');
const allScssFiles = glob.sync('./src/scss/partials/**/*.scss');

const allEntries = allScssFiles.reduce((acc, file) => {
  const name = path.basename(file, '.scss');
  const folderName = file.split('/')[4];
  acc[folderName+'/'+name] = file;
  return acc;
}, {});

// Custom plugin to display messages during the compilation process
class CustomMessagesPlugin {
  apply(compiler) {
    compiler.hooks = compiler.hooks || {};
    // Adds a hook to the compilation process to display a message
    compiler.hooks.compile.tap('CustomMessagesPlugin', () => {
      console.log('Compilation in progress...'); // Message displayed when the compilation starts
    });
  }
}

// Determines if the environment is in production mode or not
let isProd = (process.env.NODE_ENV === 'production');

// Configures plugins based on the environment (production or development)
let pluginsConfig = [];

if (isProd) {
  // Plugins specific to production mode
  pluginsConfig = [
    new RemoveEmptyScriptsPlugin(),
    new CleanWebpackPlugin({
      cleanStaleWebpackAssets: false // Avoid deleting stale assets in the dist folder
    }),
    new MiniCssExtractPlugin({ filename: 'css/[name].css' }), // Generates CSS files
  ];
} else {
  // Plugins specific to development mode
  pluginsConfig = [
    new RemoveEmptyScriptsPlugin(),
    new CleanWebpackPlugin({
      cleanStaleWebpackAssets: false
    }),
    new MiniCssExtractPlugin({ filename: 'css/[name].css' }),
    new webpack.SourceMapDevToolPlugin({}), // Enables source maps for easier debugging
    new CustomMessagesPlugin(), // Uses the custom plugin to display messages
  ];
}

// Webpack configuration export
module.exports = {
  devtool: isProd ? false : 'source-map', // Uses source maps in development only
  mode: isProd ? 'production' : 'development', // Production or development mode
  stats: 'minimal', // Limits the logs displayed during compilation
  watch: !isProd, // Enables watch mode in development
  entry: {
    // Entry points for various JS and SCSS files
    'index': ['./src/js/index.js'],
    //Theme BO.
    'ckeditor':  ['./src/scss/templates/ckeditor.scss'],
    'gin-override':  ['./src/scss/templates/gin-override.scss'],
    //Theme FO.
    'base':      ['./src/scss/templates/base.scss'],
    ...allEntries,
  },
  output: {
    filename: 'js/[name].js', // Output name for JS files
    chunkFilename: 'js/async/[name].chunk.js', // Output name for async JS chunks
    path: path.resolve(__dirname, 'dist'), // Output folder
    pathinfo: true, // Includes path information for easier debugging
    publicPath: '../', // Public path used by the generated files
  },
  devServer: {
    static: {
      directory: path.join(__dirname, 'dist/'), // Folder served by the development server
    },
    compress: true, // Enables gzip compression
    port: 9000, // Port for the development server
    hot: true, // Enables hot reloading
    devMiddleware: {
      writeToDisk: true, // Writes generated files to disk
    },
  },
  optimization: {
    minimize: true, // Enables file minimization
    minimizer: [
      new TerserPlugin({
        extractComments: false, // Disables comment extraction into a separate file
      }),
    ],
  },
  module: {
    rules: [
      {
        test: /\.js$/, // JS files
        exclude: /node_modules/, // Excludes files in node_modules
        use: {
          loader: 'babel-loader', // Transpiles with Babel
        },
      },
      {
        test: /\.twig$/, // Twig files
        use: [
          {
            loader: 'twig-loader', // Loader for Twig files
          },
        ],
      },
      {
        test: /\.(css|scss)$/, // CSS and SCSS files
        use: [
          {
            loader: MiniCssExtractPlugin.loader, // Extracts CSS into separate files
            options: {
              name: '[name].[ext]?[hash]', // Adds a hash to the CSS files
            },
          },
          {
            loader: 'css-loader', // Loads CSS files with source maps
            options: {
              sourceMap: !isProd,
              importLoaders: 2,
            },
          },
          {
            loader: 'postcss-loader', // PostCSS with plugins
            options: {
              sourceMap: !isProd,
              postcssOptions: {
                plugins: [
                  autoprefixer(), // Automatically adds CSS prefixes
                  ['postcss-perfectionist', {
                    format: 'expanded', // Formats CSS for better readability
                    indentSize: 2,
                    trimLeadingZero: true,
                    zeroLengthNoUnit: false,
                  }],
                ],
              },
            },
          },
          {
            loader: 'sass-loader', // Loader for SCSS files
            options: {
              sourceMap: !isProd,
            },
          },
        ],
      },
      {
        test: /\.(png|jpg|jpeg|gif)$/, // Image files
        type: 'asset/resource', // Handles images as resources
        generator: {
          filename: 'img/[name][ext]', // Output folder for images
        },
      },
      {
        test: /work-sans.*\.(eot|ttf|woff|woff2)$/, // Work Sans fonts
        type: 'asset/resource', // Handles fonts as resources
        generator: {
          filename: 'fonts/work-sans/[name][ext]', // Output folder for fonts
        },
      },
      {
        test: /\.svg$/, // SVG files
        type: 'asset/resource', // Handles SVGs as resources
        generator: {
          filename: 'icons/[name][ext]', // Output folder for icons
        },
      },
    ],
  },
  resolve: {
    alias: {
      media: path.join(__dirname, 'media'), // Alias for media files
      settings: path.join(__dirname, 'media/settings'), // Alias for settings files
      font: path.join(__dirname, 'font'), // Alias for fonts
    },
    modules: [
      path.join(__dirname, 'node_modules'), // Looks for modules in node_modules
    ],
    extensions: ['.js', '.json'], // Automatically resolved extensions
  },
  plugins: pluginsConfig, // Plugins configuration
  watchOptions: {
    aggregateTimeout: 300, // Delay before recompilation (in ms)
    ignored: ['**/*.woff', '**/*.json', '**/*.woff2', '**/*.jpg', '**/*.png', '**/*.svg', 'node_modules'], // Files ignored during watch
  },
};
